;;  -------------------------------------------------------------------
;;  NOM:        ESCALAR.ASM
;;  CREAT PER:  Sergio Blanco Cuaresma, Francesc Galiano Baixaul
;;  DATA:       05/04/2001
;;  DESCRIPCIO: Programa en ensamblador que calcula el producte escalar
;;		de dos vectors. **Corregida**
;;  -------------------------------------------------------------------

        ASSUME cs:Codi, ds:Dades, ss:Pila

Pila SEGMENT STACK 'stack'      ; Declaraci del Segment de pila
        DW 256 DUP (?)          ; (pot contenir fins a 256 words)
Pila ENDS



Dades SEGMENT           ; Declaraci del Segment de dades
        ; Lloc per posar la DEFINICIO DE LES VARIABLES:
        ;                   ##########################
	Vector1  DW  2,2,2
	Vector2  DW  255,255,255
	Resultat DW  (?)
        
Dades ENDS
ELEMENTS	EQU	3


Codi SEGMENT            ; Declaraci del Segment de codi
        ; Lloc per posar el CODI DE LES SUBRUTINES:
        ;                   ######################

ProducteEscalar PROC
	push	ax		;Registres que seran modificats
	push	bx
	push	si
	push	di
	mov	si, ax	;Els desplaaments estan ara continguts a registres
	mov	di, bx	;punters
	mov	bx, 0	;A BX anirem guardant el resultat temporal
	mov	ch, 0	;Aprofitem que a CL hi ha el num. d'elements
			;ja que loop saltara fins que CX sigui 0.
bucle:	mov	ax, ES:[SI]
	mul	word ptr ES:[DI]
	add	si, 2	;Segent posici dels vectors (2 pq es de words)
	add	di, 2
	add	bx, ax
	loop	bucle
	mov	dx, bx	;Resultat final
	pop	di
	pop	si
	pop	bx
	pop	ax
	ret
ProducteEscalar ENDP

Principal PROC          ; Programa principal: s el que s'executar
        mov     ax, Dades       ; Inicialitzar DS per poder accedir a
        mov     ds, ax          ;       les variables del segment Dades
    
        ; Lloc per posar el CODI DEL PROGRAMA PRINCIPAL:
        ;                   ###########################
	mov	ax, SEG vector1		;Parmetres per referncia
	mov	es, ax
	mov	ax, OFFSET vector1
	mov	bx, OFFSET vector2
	mov	cl, ELEMENTS
	
	call ProducteEscalar
	mov	resultat, dx
	
        mov     ah, 4Ch         ; Indicar al SO que s'ha acabat el programa
        mov     al, 0           ;       Codi de sortida (Exit code)
        int     21h
Principal ENDP


Codi ENDS


        END     Principal

